package Controladores;

import Model.Exceptions.ErrorDeEjecucion;

public class ParserAyudaComandos {
	
	private static Comandos[] comandos = {new Jugar(), new Reiniciar(), new Poner(), new Deshacer(), new PonerJugador(),
		new Ayuda(), new Salir()};
	
	public static Comandos parseaComando(String entrada) throws ErrorDeEjecucion{
		
		//Definimos un comando
		Comandos comando = null;
		//Dividimos el string en un array de Strings
		String delimitador = " +";
		String[] palabras = entrada.split(delimitador);
		//Recorremos el array de comandos para ver que comando tiene que parsear el array de Strings
		int i = 0;
		boolean comandoEncontrado = false;
		while((!comandoEncontrado) && (i < comandos.length)){
			comando = comandos[i].parsea(palabras);
			if(comando != null){
				comandoEncontrado = true;
			}
			else{
				i++;
			}
		}
		if(comando == null){
			throw new ErrorDeEjecucion("COMANDO INCORRECTO.");
		}
		return comando;
		
	}
	
	public static String ayudaComandos(){
		String ayuda = "";
		ayuda = ayuda + (System.getProperty("line.separator"));
		ayuda = ayuda + ("Ayuda");
		ayuda = ayuda + (System.getProperty("line.separator"));
		ayuda = ayuda + ("=======================");
		ayuda = ayuda + (System.getProperty("line.separator"));
		ayuda = ayuda + (System.getProperty("line.separator"));
		for(int i = 0; i < comandos.length; i++){
			ayuda = ayuda + ParserAyudaComandos.comandos[i].textoAyuda();
		}
		return ayuda;
		
	}

}
