package Model.Movimientos;

import Model.Enumerate.*;
import Model.Exceptions.*;
import Model.Tablero;

public abstract class Movimiento {
	
	protected int fila;
	protected int columna;
	protected Ficha color;
	
	//Construcctoras
	public Movimiento(int columna, Ficha turno){
		
		this.columna = columna;
		this.color = turno;
		
	}
	
	//Este constructor es para el movimiento Gravity
	public Movimiento(int fila, int columna, Ficha turno){
		
		this.fila = fila;
		this.columna = columna;
		this.color = turno;
		
	}
	
	//Accedentes y mutadores
	public Ficha getTurno(){
		return this.color;
		
	}
	
	public void setTurno(Ficha turno){
		this.color = turno;
		
	}
	
	public int getFila(){
		return this.fila;
		
	}
	
	public void setFila(int fila){
		this.fila = fila;
		
	}
	
	public int getColumna(){
		return this.columna;
		
	}
	
	public void setColumna(int columna){
		this.columna = columna;
		
	}
	
	public abstract void ejecutaMovimiento(Tablero tablero) throws ColumnaLlena, FilaIncorrecta, ColumnaIncorrecta, ErrorDeEjecucion;
	
	public abstract void undo(Tablero tablero);

}
