package Model.Movimientos;

import Model.Enumerate.*;
import Model.Tablero;
import Model.Exceptions.ColumnaIncorrecta;
import Model.Exceptions.ColumnaLlena;


public class MovimientoConecta4 extends Movimiento {
	
	//Constructor
	public MovimientoConecta4(int columna, Ficha turno){
		
		super(columna, turno);
		
	}
	
	private int devuelveFilaLibre(int columna, Tablero tablero){
		boolean filaEncontrada = false;
		int fila = 0;
		while ((fila < tablero.getAlto()) && (!filaEncontrada)){
			if(tablero.getFicha(fila, columna) == Ficha.VACIA){
				filaEncontrada = true;
				
			}
			else{
				fila++;
				
			}
			
		}
		if(fila == tablero.getAlto()){
			fila = -1;
			
		}
		return fila;
		
	}
	
	private boolean columnaCorrecta(Tablero tablero){
		
		boolean columnaValida = tablero.columnaCorrecta(this.getColumna());
		return columnaValida;
		
	}
	
	private boolean columnaLlena(Tablero tablero){
		boolean columnaCompleta = false;
		int fila = this.devuelveFilaLibre(this.getColumna(), tablero);
		if(fila == -1){
			columnaCompleta = true;
		}
		
		return columnaCompleta;
		
	}

	@Override
	public void ejecutaMovimiento(Tablero tablero) throws ColumnaLlena, ColumnaIncorrecta {
		// TODO Auto-generated method stub
		if(!this.columnaCorrecta(tablero)){
			throw new ColumnaIncorrecta(tablero.getAncho());
			
		}
		else if(this.columnaLlena(tablero)){
			//A lo mejor aqui hay que poner this.getColumna+1
			throw new ColumnaLlena(this.getColumna());
			
		}
		else{
			this.setFila(this.devuelveFilaLibre(this.getColumna(), tablero));
			tablero.setFicha(this.getFila(),this.getColumna(),this.getTurno());
			
		}

	}

	@Override
	public void undo(Tablero tablero) {
		// TODO Auto-generated method stub
		tablero.setFicha(this.getFila(), this.getColumna(), Ficha.VACIA);

	}

}
